package hashmap;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;

/**
 *
 * @author Matthijs Kuiper
 */
public class DataFormat {
    List<Variable> variables = new ArrayList<Variable>();

    public DataFormat(String FormatDefLocation) {
        /* First we read a file with information
         * a line looks like this:
         *  name of variabele, location first bit, length, multiplication, sommation
         */

        String variable;
        try {
			BufferedReader reader = new BufferedReader(new FileReader(FormatDefLocation));
            while ((variable = reader.readLine()) != null) {
                String[] variable_split = variable.split(",");
                String name = variable_split[0];
                int start = Integer.parseInt(variable_split[1]);
                int length = Integer.parseInt(variable_split[2]);
                double multiplier = Double.parseDouble(variable_split[3]);
                double somation = Double.parseDouble(variable_split[4]);
                variables.add(new Variable(name, multiplier, somation, start, length));
            }
        }
		catch(FileNotFoundException e) {
			System.out.println("FILE '" + FormatDefLocation + "' NOT FOUND");
			e.printStackTrace();
		}
		catch(java.io.IOException e) {
            e.printStackTrace();
        }
    }
        
    

    public ListIterator<Variable> getIterator(){
        return variables.listIterator();
    }

}
