package hashmap;

import java.awt.Dimension;
import java.util.ArrayList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.TitledBorder;

public class DataJPanel extends JPanel {

    private JScrollPane jsp;
    private JPanel innerPanel;
    private ArrayList<DataJLabel> labels = new ArrayList<DataJLabel>();
    private int width;

    public DataJPanel(int w, int h, String bordername) {
        width = w - 20;
        innerPanel = new JPanel();
        jsp = new JScrollPane(innerPanel);
		jsp.getVerticalScrollBar().setUnitIncrement(16);
        jsp.setPreferredSize(new Dimension(width, h - 40));
        innerPanel.setLayout(null);
        setBorder(new TitledBorder(bordername));
        add(jsp);
    }

    public void addLabel(DataJLabel label) {
        labels.add(label);
        innerPanel.add(label);
        innerPanel.setPreferredSize(new Dimension(width-20, labels.size() * 20));
        label.setBounds(5, (labels.size()-1) * 20, width, 15);
    }

    /**
     * this function calls the special DataFrame update function for each
     * DataJLabel on this panel
     *
     * @param data the DataFrame to be displayed
     */
    public void Update(DataFrame data) {
        for (DataJLabel label : labels)
            label.Update(data);
    }
}
